program hmt2emf;

uses
 windows,
 SysUtils,
 classes,
 graphics,
 hotimage,
 hotparse;

var
  HS: THotSpots;
  F: TFileStream;
  BoundRect:TRect;
  MF: TMetaFile;
  MFC: TMetaFileCanvas;
  i: integer;
  P: TPoint;
  DC: HDC;
  OutFN: TFileName;
begin

  Writeln ('HotSpots to metafile (*.wmf/*.emf) conversion utility');
  Writeln('Copyright 1998 Miachin Alexander (MAA)');
  Writeln;
 if ParamCount<1 then
 begin
   writeln('Usage hmt2emf <filename.hmt> [outputfile]');
   exit;
 end;

 HS := THotSpots.Create(nil);
 try
 If CompareText(ExtractFileExt(ParamStr(1)),'.hmp') = 0 then
 begin
   Writeln('Binary format assumed');
   F := TFileStream.Create(ParamStr(1), fmOpenRead or fmShareDenyRead);
   try
     HS.LoadFromStream(F);
   finally
     F.Free;
   end;
 end
  else
  begin
    Writeln('Text format assumed');
    ReadHSfromFile(ParamStr(1),HS);
  end;
    if HS.Count > 0 then
    begin
      Writeln(HS.Count,' spots was found in file');
      BoundRect := HS.GetBoundsRect;
      MF := TMetaFile.Create;
      MF.Width :=BoundRect.Right;
      MF.Height := BoundRect.Bottom;
      Writeln('ImageSize: ',BoundRect.Right,'x',BoundRect.Bottom);
      DC := GetDC(0);

//      IntersectClipRect(DC, 0, 0, BoundRect.Right,BoundRect.Bottom);
      MFC := TMetaFileCanvas.Create(MF, DC);
      for i := 0 to HS.Count -1 do
         HS.Spots[i].DrawShape(MFC, P, false);
      MFC.Free;
      ReleaseDC(0,DC);

      if ParamCount >1 then OutFN := ParamStr(2)
       else 
          OutFN := ChangeFileExt(ParamStr(1),'.EMF');
      MF.SaveToFile(OutFN);

      Writeln('Output emf is saved to: ', OutFN);
      MF.Free;

    end;


 finally
   HS.Free;
 end;

end.
